/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ʸϤʤƺ()

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jan.20.2000  gdk_imlib_init() ȴƤΤǺ
  Jan.18.2000  
  Jan.14.2000  פդΤ :-)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ᥤץʤ
  RRMain              -- ֤˥뤵ᥤ
  RRMainFree          -- ᥤץཪλ()
  RRMainWindowSize    -- եå
  RRMainInterval      -- ߻֤
  RRMainIntervalTime  -- ߻֤ɤߤ
  RRMainPicture       -- ؤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_switch.h"
#include  "rr_picture.h"
#include  "rr_njan.h"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

enum {
  MAIN_INIT = 0,
  MAIN_TITLE_WAIT,
  MAIN_TITLE,
  MAIN_WIPE_INIT,
  MAIN_WIPE,
  MAIN_GAME_INIT,
  MAIN_GAME,
  MAIN_GAME_AFTER
};

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ߤγ */
static gint  interval;
static gint  int_handle;

/* --- ǡ */
static GtkWidget  *pic1;
static GtkWidget  *pic2;
static GtkWidget  *mask;

/* --- ᥤ롼ץޡ */
static gint  timer;

/* --- ᥤ󥹥ƥå */
static gint  step;

/* --- Ͼ */
static gboolean  click;
static gchar     key;

/* --- 磻ѥ֥ */
static RRSprite obj;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  GtkWidget *sc;
  GtkStyle  *style;
  gchar fontset[256];

  int_handle = 0;

  timer = 0;
  step = MAIN_INIT;

  srand((unsigned int)time(NULL));

  /* --- ꥽ˤäƻꤵƤ(Τ)
         եȤWidgetȴ */
  sc = RRScreenCanvas();
  style = gtk_rc_get_style(sc);
  sprintf(fontset, "%s,%s",
	  style->rc_style->font_name, style->rc_style->fontset_name);
  RRScreenFontSetInit(fontset);

  /* -- ߳ */
  RRMainInterval(INTERVAL);


  /* -- եå pixmap  */
  gdk_imlib_init();
  pic1 = RRPictureFromFile(RRScreenWindow(), PICFILE1);
  pic2 = RRPictureFromFile(RRScreenWindow(), PICFILE2);
  mask = create_pixmap(RRScreenWindow(), MASKFILE);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  if (pic1 != NULL) gtk_widget_unref(pic1);
  if (pic2 != NULL) gtk_widget_unref(pic2);
  if (mask != NULL) gtk_widget_unref(mask);
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMainClick         -- ɥå줿餷

   return : void
   gint x, y ٥Ȥɸ
-------------------------------------------------------------- */
void RRMainClick(gint x, gint y)
{
  click = TRUE;
  NJClick(x, y);
}


/* -------------------------------------------------------------
  RRMainKeyin         -- 줿餷

   return : void
   gchar  in(줿ȥå׾)
-------------------------------------------------------------- */
void RRMainKeyin(gchar in)
{
  key = in;
  NJKeyin(in);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  /* --- ॷƥᥤ󥹥ƥå */
  switch(step) {
  case MAIN_INIT:
    /* -- ȥɽ */
    {
      GdkPixmap *pic;
      GdkBitmap *mask;

      gtk_pixmap_get(GTK_PIXMAP(pic1), &pic, &mask);
      RRScreenPutPixmap(pic, 0, 0);
      timer = (1 * INTERVAL) / 2;
      step = MAIN_TITLE_WAIT;
    }
    break;

  case MAIN_TITLE_WAIT:
    /* -- ԤޤǤäȴ֤֤ */
    if ((--timer) <= 0) {
      step = MAIN_TITLE;
    }
    break;

  case MAIN_TITLE:
    /* -- ȤΥԤ */
    if (click == TRUE) {
      step = MAIN_WIPE_INIT;
    }
    break;

  case MAIN_WIPE_INIT:
    /* -- ̥磻פν */
    {
      GdkPixmap *pic;
      GdkBitmap *mask_tmp;

      gtk_pixmap_get(GTK_PIXMAP(pic2), &pic, &mask_tmp);
      obj.sw = TRUE;
      obj.mask_offset = FALSE;
      obj.objmap = pic;
      gtk_pixmap_get(GTK_PIXMAP(mask), &pic, &mask_tmp);
      obj.objmask = mask_tmp;
      obj.x = obj.y = 0;
      obj.w = 72;
      obj.h = 360;
      obj.ox = obj.oy = 0;
      obj.offset_x = obj.offset_y = 0;
      timer = (480 / 8) + 18;
      step = MAIN_WIPE;
    }

  case MAIN_WIPE:
    /* -- ̥磻 */
    obj.x = obj.ox = 480 - (8 * timer);
    RRScreenObjPut(&obj);
    if ((--timer) < 0) {
      timer = 1 * INTERVAL;
      step = MAIN_GAME_INIT;
    }
    break;

  case MAIN_GAME_INIT:
    /* -- Τν */
    if ((--timer) < 0) {
      NJInit(fw, fh);
      step = MAIN_GAME;
    }
    break;

  case MAIN_GAME:
    /* --  */
    NJMain();
    if (NJStat() == FALSE) {
      /* ä; */
      timer = (1 * INTERVAL) / 2;
      step = MAIN_GAME_AFTER;
    }
    break;

  case MAIN_GAME_AFTER:
    /* -- äʤ */
    if ((--timer) <= 0) {
      NJFree();
      step = MAIN_INIT;
    }
    break;

  }


  /* --- ϾΥꥢ(ǡͭ1ե졼Τ) */
  click = FALSE;
  key = 0;

  return 1;
}


